VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Gaussian filter kernel"
   ClientHeight    =   3990
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6345
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3990
   ScaleWidth      =   6345
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command2 
      Caption         =   "Exit"
      Height          =   495
      Left            =   5040
      TabIndex        =   8
      Top             =   3240
      Width           =   1035
   End
   Begin VB.TextBox Text3 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   5040
      TabIndex        =   4
      Text            =   "40"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.TextBox Text2 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   5040
      TabIndex        =   3
      Text            =   "181"
      Top             =   660
      Width           =   1035
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   5040
      TabIndex        =   2
      Text            =   "181"
      Top             =   300
      Width           =   1035
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Go!"
      Height          =   495
      Left            =   5040
      TabIndex        =   1
      Top             =   1380
      Width           =   1035
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   3500
      Left            =   240
      ScaleHeight     =   229
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   229
      TabIndex        =   0
      Top             =   240
      Width           =   3500
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Sigma:"
      Height          =   195
      Left            =   4500
      TabIndex        =   7
      Top             =   1080
      Width           =   480
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Kernel size Y:"
      Height          =   195
      Left            =   4020
      TabIndex        =   6
      Top             =   780
      Width           =   960
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Kernel size X:"
      Height          =   195
      Left            =   4020
      TabIndex        =   5
      Top             =   420
      Width           =   960
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const Pi As Double = 3.14159265358979

Private Function GetGaussianFilterKernel(SizeX As Integer, SizeY As Integer, Sigma As Single) As Double()

Dim X As Integer
Dim Y As Integer
Dim HalfSizeX  As Integer
Dim HalfSizeY  As Integer
Dim Kernel() As Double

ReDim Kernel(0 To SizeX, 0 To SizeY) As Double

HalfSizeX = SizeX \ 2
HalfSizeY = SizeY \ 2

For X = 0 To SizeX
    For Y = 0 To SizeY
        Kernel(X, Y) = (1 / (2 * Pi * (Sigma * Sigma))) * Exp(-((((X - HalfSizeX) * (X - HalfSizeX)) + ((Y - HalfSizeY) * (Y - HalfSizeY))) / (2 * (Sigma * Sigma))))
    Next
Next

GetGaussianFilterKernel = Kernel

End Function

Private Sub Command1_Click()

Dim UseKernel() As Double
Dim X As Long
Dim Y As Long
Dim PosX As Integer
Dim PosY As Integer
Dim MySizeX As Integer
Dim MySizeY As Integer
Dim MySigma As Single
Dim MyHalfSizeX As Integer
Dim MyHalfSizeY As Integer
Dim MaxKernel As Double

MySizeX = Val(Form1.Text1)
MySizeY = Val(Form1.Text2)
MySigma = Val(Form1.Text3)

MyHalfSizeX = MySizeX \ 2
MyHalfSizeY = MySizeY \ 2

UseKernel = GetGaussianFilterKernel(MySizeX, MySizeY, MySigma)
MaxKernel = UseKernel(MyHalfSizeX, MyHalfSizeY)

For X = 0 To MySizeX 'Normalize kernel for more convenience
    For Y = 0 To MySizeY
        UseKernel(X, Y) = UseKernel(X, Y) / MaxKernel
    Next
Next

For X = 0 To Form1.Picture1.ScaleWidth
    For Y = 0 To Form1.Picture1.ScaleHeight
        PosX = Int((X / Form1.Picture1.ScaleWidth) * MySizeX)
        PosY = Int((Y / Form1.Picture1.ScaleHeight) * MySizeY)
        Form1.Picture1.PSet (X, Y), RGB(255 * UseKernel(PosX, PosY), 255 * UseKernel(PosX, PosY), 255 * UseKernel(PosX, PosY))
    Next
Next

End Sub

Private Sub Command2_Click()

Unload Me

End Sub
